#ifndef __INCHANNELS_H
#define __INCHANNELS_H

#include "generic.h"
#include "xaudio/decoder.h"

class Mp3Channel {
private:

  int spawn();

public:

  Mp3Channel();
  ~Mp3Channel();

  short gotin[BUF_SIZE];
  int sample_rate; /* must be setted when the channel is created */

  int stream[2];
  pid_t pid;
  char *name;
  float volume;
  float speed;
  int rate;
  int channels;
  bool end;
  bool on;
  char playlist[MAX_PLAYLIST_ENTRY][MAX_PATH_SIZE];
  int playlist_len;

  /* this must be setted if dsp is opened to let close the fd
     for the forked mpg123 */
  int *dsp;
  
  void start(int plpos);
  void stop();
  void ends();

  unsigned int get_audio();
  void get_playlist(char *plfile);
};

class XaudioChannel {
private:
  XA_DecoderInfo *decoder;

public:
  XaudioChannel();
  ~XaudioChannel();
  bool set(int plpos);
  bool play();
  bool stop();
  bool pos(float pos);
  float get_audio();
  bool get_playlist(char *pl);

  float volume;
  float position;

  XA_InputInfo *input;
  XA_StatusInfo *status;
  XA_OutputBufferInfo *buffer;

  char playlist[MAX_PLAYLIST_ENTRY][MAX_PATH_SIZE];
  int playlist_len;
  
  int selected;
  enum mode { LOOP, CONTINOUS, SINGLEPLAY };
  bool on;
  bool opened;

};

class LiveIn {
 private:
  int *dsp;
  unsigned int num_samples;
  int sample_rate;
  int opt;

 public:
  LiveIn(int smpr, int chans, int *thedsp);
  ~LiveIn();
  
  bool get_audio();

  short gotin[BUF_SIZE];
  int channels;
  int rate;
  bool on;
};

#endif
